#include "h/types.h"
#include "h/emuPalette.h"
#include "../nes/h/nesGeneral.h"
#include "../nes/h/ppu.h"

namespace Reminesce
{

void ntView(int pitch, void *surface)
{
	u8 X1, X2, tile, t;
	u8 colour, highBits, tileSet, attributeShift;

	if (!imageLoaded)
		return;
	highBits = 0;

	tileSet =  (ppu.r2000 & 16) ? 4 : 0;
	for (u8 ntY=0;		ntY<2;		ntY++)		{
	for (u8 ntX=0;		ntX<2;		ntX++)		{
	for (u8 tileY=0;	tileY<30;	tileY++)	{
	for (u8 tileX=0;	tileX<32;	tileX++)	{
		tile  = pntBank[ntY*2 | ntX][(tileY*32 | tileX) & 0x3FF];
		attributeShift  = tileX & 2;
		attributeShift |= (tileY & 2) ? 4 : 0;
		t  = tileX /4;
		//same as below t |= (((ppu.address & 0x3E0)/32)/4)*8;
		t |= (tileY*2) & 0x38;

		highBits = (pntBank[ntY*2 | ntX][960+t] >> attributeShift) & 3;
		highBits = highBits<<2;
		for (u8 fineY=0; fineY<8; fineY++)
		{
			X1	= pChrRead[tile/64 + tileSet][((tile & 0x3f) *16) |  fineY ];
			X2	= pChrRead[tile/64 + tileSet][((tile & 0x3f) *16) | (fineY + 8)];
			
			for (u8 fineX=0; fineX<8; fineX++)
			{
				t = 1<<(7 - fineX);
				colour  = ((X1 & t) != 0) | highBits;
				colour |= ((X2 & t) != 0)<<1;

				if (colour & 3)
				{
					if (pal16)
						((short*)surface)[((tileY*8 | fineY) + (ntY*241))*pitch + (tileX*8 | fineX) + (ntX*257)] = pal16[pal[colour]];
					if (pal24)
						*(long*)((long)surface + ((tileY*8 | fineY) + (ntY*241))*pitch +  ((tileX*8 | fineX) + (ntX*257))*3) = pal24[pal[colour]];
					else if (pal32)
						((long*)surface)[((tileY*8 | fineY) + (ntY*241))*pitch + (tileX*8 | fineX) + (ntX*257)] = pal32[pal[colour]];
				}
				else
				{
					int p;
					if (pal16)
					{
						p  = (tileY*8 | fineY) + (ntY*241);
						p *=  pitch;
						p += (tileX*8 | fineX) + (ntX*257);
						((short*)surface)[p] = pal16[pal[0]];
					}
					if (pal24)
					{
						p  = (tileY*8 | fineY) + (ntY*241);
						p *=  pitch;
						p += ((tileX*8 | fineX) + (ntX*257))*3;

						*(long*)((long)surface + p) = pal24[pal[0]];
					}
					else if (pal32)
					{
						p  = (tileY*8 | fineY) + (ntY*241);
						p *=  pitch;
						p += (tileX*8 | fineX) + (ntX*257);

						((long*)surface)[p] = pal32[pal[0]];
					}
				}
			}
		}
	}
	}
	}
	}
}


void tileView(int pitch, void *psurface)
{
	int x, X1, X2, y, tile, temp;
	u8 colour, highBits, tileSet;
	
	if (!imageLoaded)
		return;

	highBits = tileSet = 0;
	for (tileSet = 0; tileSet<2; tileSet++)
	{
		for (tile = 0; tile<256; tile++)
		{
			for (y = 0; y<8; y++)
			{
				X1 = pChrRead[(tile>>6)+tileSet*4][(tile & 0x3f) *16 |  (y & 7)];
				X2 = pChrRead[(tile>>6)+tileSet*4][(tile & 0x3f) *16 | ((y & 7)+8)];
				for (x = 0; x<8; x++)
				{
					temp = 1<<(7 - x);
					colour  = ((X1 & temp) != 0) | highBits;
					colour |= ((X2 & temp) != 0)<<1;

					temp  = (tile/16)*8;
					temp += y;
					temp *= pitch;
					if (pal24)
						temp += (x + (tile & 15)*8 + tileSet*8*16+tileSet)*3;
					else
						temp +=  x + (tile & 15)*8 + tileSet*8*16+tileSet;
					
					if (pal16)
						((short*)(psurface))[temp] = pal16[colour & 0x63];
					else if (pal24)
						*(long*)((long)psurface + temp) = pal24[colour & 0x63];
					else if (pal32)
						((long*)(psurface))[temp] = pal32[colour & 0x63];
				}
			}
		}
	}
}

}
