#include "h/types.h"

namespace Reminesce
{

u32 *pal32 = 0;
u32 *pal24 = 0;
u16 *pal16 = 0;

void initPalette32()
{
	//Special Thanks to Chris Covell for creating this palette
	//and finding the intensity percentage
	ui r, b, g;
	if (pal32)
		return;

	if (pal24)
	{
		pal32 = pal24;
		pal24 = 0;
		return;
	}

	if (pal16)
	{
		delete [] pal16;
		pal16 = 0;
	}

	//RGB
	u8 pal [] =
	{
		0x80,0x80,0x80, 0x00,0x3D,0xA6, 0x00,0x12,0xB0, 0x44,0x00,0x96,
		0xA1,0x00,0x5E, 0xC7,0x00,0x28, 0xBA,0x06,0x00, 0x8C,0x17,0x00,
		0x5C,0x2F,0x00, 0x10,0x45,0x00, 0x05,0x4A,0x00, 0x00,0x47,0x2E,
		0x00,0x41,0x66, 0x00,0x00,0x00, 0x05,0x05,0x05, 0x05,0x05,0x05,
		0xC7,0xC7,0xC7, 0x00,0x77,0xFF, 0x21,0x55,0xFF, 0x82,0x37,0xFA,
		0xEB,0x2F,0xB5, 0xFF,0x29,0x50, 0xFF,0x22,0x00, 0xD6,0x32,0x00,
		0xC4,0x62,0x00, 0x35,0x80,0x00, 0x05,0x8F,0x00, 0x00,0x8A,0x55,
		0x00,0x99,0xCC, 0x21,0x21,0x21, 0x09,0x09,0x09, 0x09,0x09,0x09,
		0xFF,0xFF,0xFF, 0x0F,0xD7,0xFF, 0x69,0xA2,0xFF, 0xD4,0x80,0xFF,
		0xFF,0x45,0xF3, 0xFF,0x61,0x8B, 0xFF,0x88,0x33, 0xFF,0x9C,0x12,
		0xFA,0xBC,0x20, 0x9F,0xE3,0x0E, 0x2B,0xF0,0x35, 0x0C,0xF0,0xA4,
		0x05,0xFB,0xFF, 0x5E,0x5E,0x5E, 0x0D,0x0D,0x0D, 0x0D,0x0D,0x0D,
		0xFF,0xFF,0xFF, 0xA6,0xFC,0xFF, 0xB3,0xEC,0xFF, 0xDA,0xAB,0xEB,
		0xFF,0xA8,0xF9, 0xFF,0xAB,0xB3, 0xFF,0xD2,0xB0, 0xFF,0xEF,0xA6,
		0xFF,0xF7,0x9C, 0xD7,0xE8,0x95, 0xA6,0xED,0xAF, 0xA2,0xF2,0xDA,
		0x99,0xFF,0xFC, 0xDD,0xDD,0xDD, 0x11,0x11,0x11, 0x11,0x11,0x11
	};

	int i, n;
	pal32 = new u32 [16*64];

	for (i = 0; i < 64; i++)
	{
		pal32[i] =
			(pal[i*3+0]<<16) | 
			(pal[i*3+1]<< 8) |
			(pal[i*3+2]<< 0);

		r = (ui)(pal[i*3+0]*1.239);
		g = (ui)(pal[i*3+1]*0.915);
		b = (ui)(pal[i*3+2]*0.743);
		if (r > 255) r = 255; if (g > 255) g = 255; if (b > 255) b = 255;
		pal32[i+1*64] = (r<<16) | (g<<8) | b;

		r = (ui)(pal[i*3+0]*0.794);
		g = (ui)(pal[i*3+1]*1.086);
		b = (ui)(pal[i*3+2]*0.882);
		if (r > 255) r = 255; if (g > 255) g = 255; if (b > 255) b = 255;
		pal32[i+2*64] = (r<<16) | (g<<8) | b;

		r = (ui)(pal[i*3+0]*1.019);
		g = (ui)(pal[i*3+1]*0.980);
		b = (ui)(pal[i*3+2]*0.653);
		if (r > 255) r = 255; if (g > 255) g = 255; if (b > 255) b = 255;
		pal32[i+3*64] = (r<<16) | (g<<8) | b;
		
		r = (ui)(pal[i*3+0]*0.905);
		g = (ui)(pal[i*3+1]*1.026);
		b = (ui)(pal[i*3+2]*1.277);
		if (r > 255) r = 255; if (g > 255) g = 255; if (b > 255) b = 255;
		pal32[i+4*64] = (r<<16) | (g<<8) | b;

		r = (ui)(pal[i*3+0]*1.023);
		g = (ui)(pal[i*3+1]*0.908);
		b = (ui)(pal[i*3+2]*0.979);
		if (r > 255) r = 255; if (g > 255) g = 255; if (b > 255) b = 255;
		pal32[i+5*64] =	(r<<16) | (g<<8) | b;

		r = (ui)(pal[i*3+0]*0.741);
		g = (ui)(pal[i*3+1]*0.987);
		b = (ui)(pal[i*3+2]*1.001);
		if (r > 255) r = 255; if (g > 255) g = 255; if (b > 255) b = 255;
		pal32[i+6*64] = (r<<16) | (g<<8) | b;

		r = (ui)(pal[i*3+0]*0.750);
		g = (ui)(pal[i*3+1]*0.750);
		b = (ui)(pal[i*3+2]*0.750);
		if (r > 255) r = 255; if (g > 255) g = 255; if (b > 255) b = 255;
		pal32[i+7*64] = (r<<16) | (g<<8) | b;
	}

	for (n = 0; n< 8; n++)
	{
		for (i = 0; i<64; i++)
			pal32[(n+8)*64 + i] = pal32[n*64 + (i & 0x30)];
	}
}

void initPalette24()
{
	if (pal24)
		return;

	if (pal32)
	{
		pal24 = pal32;
		pal32 = 0;
		return;
	}

	if (pal16)
	{
		delete [] pal16;
		pal16 = 0;
	}

	initPalette32();
	pal24 = pal32;
	pal32 = 0;
}

void initPalette16()
{
	if (pal16)
		return;

	if (pal24)
	{
		pal32 = pal24;
		pal24 = 0;
	}

	if (!pal32)
		initPalette32();

	pal16 = new u16 [16*64];

	for (int c = 0; c < 8; c++) {
	for (int i = 0; i < 64; i++) {
		pal16[c*64 + i] =
			(u16) (((pal32[c*64 + i]>> 3) & 0x1F)<< 0) |
			(u16) (((pal32[c*64 + i]>>10) & 0x3F)<< 5) |
			(u16) (((pal32[c*64 + i]>>19) & 0x1F)<<11);
	}
	}

	if (pal32)
	{
		delete [] pal32;
		pal32 = 0;
	}
	if (pal24)
	{
		delete [] pal24;
		pal24 = 0;
	}

}

void initPalette15()		//Will use the pal16 palette pointer since it is 2 bytes.
{
	if (pal16)
		return;

	if (pal24)
	{
		pal32 = pal24;
		pal24 = 0;
	}

	if (!pal32)
		initPalette32();

	pal16 = new u16 [16*64];

	for (int c = 0; c < 8; c++) {
	for (int i = 0; i < 64; i++) {

/*		pal16[c*64 + i] =
			(u16) (((pal32[c*64 + i]>> 3) & 0x1F)<< 0) |
			(u16) (((pal32[c*64 + i]>>11) & 0x1F)<< 5) |
			(u16) (((pal32[c*64 + i]>>19) & 0x1F)<<10) |
			0x8000;
*/
		pal16[c*64 + i] =
			(u16) (((pal32[c*64 + i]>> 3) & 0x1F)<< 10)|
			(u16) (((pal32[c*64 + i]>>11) & 0x1F)<< 5) |
			(u16) (((pal32[c*64 + i]>>19) & 0x1F)<<0) | 0x8000;
//*/
	}
	}

	if (pal32)
	{
		delete [] pal32;
		pal32 = 0;
	}
	if (pal24)
	{
		delete [] pal24;
		pal24 = 0;
	}
}

void destoryPalette()
{
	if (pal16)
	{
		delete [] pal16;
		pal16 = 0;
	}
	if (pal24)
	{
		delete [] pal24;
		pal24 = 0;
	}
	if (pal32)
	{
		delete [] pal32;
		pal32 = 0;
	}
}

}
