#include	"../DLL/d_iNES.h"

static	struct
{
	u8 Bank, Mode;
}	Mapper;

static	void	Sync (void)
{
	MP->SetCHR_RAM8(0,0);
	if (Mapper.Mode & 1)
		MP->SetPRG_ROM8(0x6,Mapper.Bank | 0x23);
	else	MP->SetPRG_ROM8(0x6,Mapper.Bank | 0x2F);
	if (Mapper.Mode == 2)
		MP->SetPRG_ROM16(0x8,(Mapper.Bank >> 1) | 1);
	else	MP->SetPRG_ROM16(0x8,Mapper.Bank >> 1);
	if (Mapper.Mode & 1)
		MP->SetPRG_ROM16(0xC,(Mapper.Bank >> 1) | 1);
	else	MP->SetPRG_ROM16(0xC,(Mapper.Bank >> 1) | 7);
	if (Mapper.Mode == 3)
		MP->Mirror_H();
	else	MP->Mirror_V();
}

static	void	__cdecl	SaveMI (Ar128 MI)
{
	u8 x = 0;
	MI[x++] = Mapper.Bank;
	MI[x++] = Mapper.Mode;
}

static	void	__cdecl	LoadMI (const Ar128 MI)
{
	u8 x = 0;
	Mapper.Bank	= MI[x++];
	Mapper.Mode	= MI[x++];
	Sync();
}

static	void	__cdecl	Write67 (int Bank, int Where, int What)
{
	Mapper.Mode = ((What & 0x10) >> 3) | ((What & 0x02) >> 1);
	Sync();
}

static	void	__cdecl	Write89ABCDEF (int Bank, int Where, int What)
{
	Mapper.Bank = (What & 0xF) << 2;
	if (Bank & 0x4)
		Mapper.Mode = (Mapper.Mode & 0x1) | ((What & 0x10) >> 3);
	Sync();
}

static	void	__cdecl	UnloadMapper (void)
{
	iNES_UnloadROM();
}

static	void	__cdecl	InitMapper (const PMapperParam _MP, int IsHardReset)
{
	u8 x;

	MP = _MP;
	iNES_InitROM();

	for (x = 0x6; x < 0x8; x++)
		MP->SetWriteHandler(x,Write67);
	for (x = 0x8; x < 0x10; x++)
		MP->SetWriteHandler(x,Write89ABCDEF);

	Mapper.Bank = 0;
	Mapper.Mode = 1;
	Sync();
}

CTMapperInfo	MapperInfo_051 =
{
	"11 in 1 Ball Games",
	51,
	MS_Full,
	8192,
	InitMapper,
	UnloadMapper,
	NULL,
	NULL,
	SaveMI,
	LoadMI,
	NULL,
	NULL
};
