namespace Reminesce
{
enum eCPU_Flags
{
	cN = 0x80,
	cV = 0x40,
	cR = 0x20,
	cB = 0x10,
	cD = 0x08,
	cI = 0x04,
	cZ = 0x02,
	cC = 0x01
};

enum eJumpVectors
{
	NMIVector = 0xFFFA,
	RESET     = 0xFFFC,
	IRQVector = 0xFFFE
};

#ifdef BIG_ENDIAN
	struct tS8
	{
		s8 h;
		s8 l;
	};
	struct tU8
	{
		u8 h;
		u8 l;
	};
#else
	struct tS8
	{
		s8 l;
		s8 h;
	};
	struct tU8
	{
		u8 l;
		u8 h;
	};
#endif

union t16
{
	tS8 s;
	tU8 u;
};


struct tCPU
{
	u8 a;
	u8 x;
	u8 y;
	u8 s;
	u16 pc;
	u8 N;
	u8 V;
	u8 D;
	u8 I;
	u8 Z;
	u8 C;
};
extern struct tCPU cpu;

union tempVar
{
	si		si_;
	u16		u16_;
	t16		t16_;
};

extern tempVar memloc, temp;
extern ui cpuCycles, cpuTargetCycles;

void runCpu(int cycles);
void runCpu2(int cycles);

//for regs
extern u16 pad[2];
extern u8 ButtonShift1, ButtonShift2, Strobing;

//platform func
void BuildKeys();

}
