
namespace Reminesce
{

enum eNesMode {
	ntscMode = 0, palMode, vsMode, pc10Mode,

	regionModeAnd	= 3,
	netPlayMode		= 4,
	inRunCpu		= 8,
	resetLoop		= 16
};

enum {
	ramSize		= 0x800,
	wramSize	= 0x400 * 64,
	NtSize		= 0x1000,
	chrramSize	= 0x4000,
	openBankSize= 0x4000,
};

extern u8 *pbankRead[32], *pbankWrite[32];
extern u8 openBanks[openBankSize], deadWrite[0x800];		//meant for 0x4000-7FFF reads and dead is for writes
extern u8 *ram, *wram;
extern u8 brunNes, imageLoaded;
extern s32 g_badOp;

void HardResetNes();
void ResetNes();
void runNes();

extern u8 nesMode;

#define pRead(Address)		(pbankRead [((u16)(Address))>>11	][(Address) & 0x7FF	])
#define pReadZp(Address)	(pbankRead [0						][ (u8)(Address)	])
#define pWrite(Address)		(pbankWrite[((u16)(Address))>>11	][(Address) & 0x7FF ])

#define pReadZp16(Address)	(pReadZp(Address)	+ (pReadZp(Address+1)<<8))

#if defined(LITTLE_ENDIAN) && defined (BIG_ENDIAN)
	#error("Cant define LITTLE_ENDIAN and BIG_ENDIAN at the same time")
#endif

#if defined(LITTLE_ENDIAN) && defined (CAN_UNALIGN_READ)
	#define pRead16(Address)	( *(short*) &pbankRead [((u16)(Address))>>11][(Address) & 0x7FF])
#else
	#define pRead16(Address)	((pRead(Address)+ (pRead(Address+1)<<8)))
#endif

}
