namespace Reminesce
{

struct tPPU
{
	u8	secondWrite;
	u8	pipe;
	u16 temp;
	u16	address;
	u8	addrInc;
	u8	vblankBit;
	u8	sprite0Hit;
	u8	spriteOver;
	u8	xLatch;
	u8	r2000;
	u8	r2001;
	u8	bus;
	u8	sprLoc;
};

extern struct tPPU ppu;
void generateRevBits();
void AttributeOffsetGenerator();

//options
extern u8 ppushowTopLines;				//show top & bottom 8 lines durring NTSC mode
extern u8 ppuClipRightSide;				//clip 8 right pixels when clipping the left 8
extern u8 drawMode;

extern u8 skipThisFrame;

//tiles
extern u8 *pChrRead[16], *pChrWrite[16], *pMyTile[16];
extern u8 *chrRam;


//sprites
extern u8 sprRam[256], sprLoc;

//palette
extern u8 pal[32];

//nametables
extern u8 *pntBank[4];
extern u8 *nameTable;

//Render
void RenderTheLine(u8 scanline, void *surface, u16 pitch);

//platform func
void RefreshGUI();
void FrameDef();
void StartFrame(ui *pitch, void **surface);
void Render();
void EndFrameNTSC();
void EndFramePAL();
}
